#include <windows.h>
#include <inttypes.h>
#include <stdio.h>
#define _WIN32_IE 0x400
#include <shlobj.h>

int main(int argc, char** argv)
{
  char buf[MAX_PATH], *p, *newp;
  char path[MAX_PATH];
  uint32_t lP, lB;
  size_t cmdlen, i;
  char* cmdline;
  STARTUPINFO si;
  PROCESS_INFORMATION proci;

  // Figure out where we are being called from...
  if (GetModuleFileName(NULL, buf, sizeof(buf)) == sizeof(buf))
    return -1;
  
  p = strrchr(buf, '\\');
  if (p != NULL)
    *p = 0;

  lB = strlen(buf);

  p = getenv("PATH");
  lP = strlen(p);
  
  if (lB > 0x8000000 || lP > 0x8000000)
    return -1;

  newp = (char*)malloc(5 + 9 + 30 + lB * 3 + lP + 3);
  memcpy(newp, buf, lB);
  memcpy(newp + lB, "\\lib;", 5);
  memcpy(newp + lB + 5, buf, lB);
  memcpy(newp + lB * 2 + 5, "\\gcc\\bin;", 9);
  memcpy(newp + lB * 2 + 5 + 9, ";", 1);
  memcpy(newp + lB * 2 + 5 + 9 + 1, buf, lB);
  memcpy(newp + lB * 3 + 5 + 9 + 1, "\\gcc\\libexec\\gcc\\mingw32\\3.4.2;", 31);
  strcpy(newp + lB * 3 + 5 + 9 + 32, p);
  SetEnvironmentVariable("PATH", newp);
  SetEnvironmentVariable("MOZILLA_FIVE_HOME", buf);

  p = getenv("LIBRARY_PATH");
  if (p != NULL)
    lP = strlen(p);
  else
    lP = 0;
  newp = (char*)malloc(lB * 2 + 36 + lP + 1);
  memcpy(newp, buf, lB);
  memcpy(newp + lB, "\\gcc\\lib\\gcc\\mingW32\\3.4.2;", 27);
  memcpy(newp + lB + 27, buf, lB);
  memcpy(newp + lB * 2 + 27, "\\gcc\\lib;", 9);
  if (lP != 0)
    strcpy(newp + lB * 2 + 27 + 9, p, lP);
  else
    newp[lB * 2 + 27 + 9] = 0;
  SetEnvironmentVariable("LIBRARY_PATH", newp);
  chdir(buf);

  /* deliberately including trailing null... */
#define CMDPREFIX "xulrunner.exe application.ini"
  cmdlen = sizeof(CMDPREFIX);
  for (i = 1; i < argc; i++)
    cmdlen += 1 + strlen(argv[i]);
  cmdline = malloc(cmdlen);
  strcpy(cmdline, CMDPREFIX);
  p = cmdline + sizeof(CMDPREFIX) - 1;
  for (i = 1; i < argc; i++)
  {
    *p++ = ' ';
    strcpy(p, argv[i]);
    p += strlen(argv[i]);
  }
  *p++ = 0;

  // Now launch xulrunner...
  memset(&si, 0, sizeof(si));
  si.cb = sizeof(si);
  CreateProcess("xulrunner.exe",
                cmdline, NULL, NULL, 0,
                CREATE_NO_WINDOW, NULL, NULL, &si, &proci);
}
